import { ConnectionBackend, RequestOptions, RequestOptionsArgs, Response, Http } from "@angular/http";
import { Observable } from "rxjs/Rx";
import { LocalStorageService } from 'angular-2-local-storage';
import { LoaderService, HttpIntegrationService } from './index';
export declare class InterceptedHttp extends Http {
    private localStorageService;
    private loaderService;
    private httpIntegrationService;
    constructor(backend: ConnectionBackend, defaultOptions: RequestOptions, localStorageService: LocalStorageService, loaderService: LoaderService, httpIntegrationService: HttpIntegrationService);
    get(url: string, options?: RequestOptionsArgs): Observable<Response>;
    post(url: string, body: string, options?: RequestOptionsArgs): Observable<Response>;
    put(url: string, body: string, options?: RequestOptionsArgs): Observable<Response>;
    delete(url: string, options?: RequestOptionsArgs): Observable<Response>;
    private getRequestOptionArgs(options?);
    private createAuthorizationHeader(headers);
    private onSuccess(res);
    private onError(res);
    private onEnd();
    private showLoader();
    private hideLoader();
}
